## soundscaperenderer 0.4.1~dfsg

=== mex/Makefile ===
# Makefile for building MEX-files

# Makefile example:
# http://www.klab.caltech.edu/~harel/share/gbvs_scale/sift/Makefile

MEXFILES ?= ssr_nfc_hoa ssr_binaural ssr_vbap ssr_aap ssr_wfs

SOURCES := ssr_global position orientation directionalpoint xmlparser

# TODO: separate libraries for different renderers?
LIBRARIES += libxml-2.0 fftw3f sndfile

APF_DIR ?= ../apf
SRC_DIR ?= ../src
MEX ?= mex -v
OCT ?= mkoctfile --mex --verbose

CXXFLAGS += -std=c++11

# optimization:
CXXFLAGS += -O3
#CXXFLAGS += -fomit-frame-pointer -ffast-math -funroll-loops
#CXXFLAGS += -march=native
CPPFLAGS += -DNDEBUG
# TODO: check for SSE?

OCTAVE_TARGETS := $(MEXFILES:%=%.octave)
MATLAB_TARGETS := $(MEXFILES:%=%.matlab)

SOURCES := $(SOURCES:%=$(SRC_DIR)/%.cpp)

CXXFLAGS += -pthread

# maybe for Mac OS X:
#CFLAGS += -fno-common -no-cpp-precomp -fexceptions

#MEX_CPPFLAGS += -DSSR_MEX_USE_DOUBLE

MEX_CPPFLAGS += -I$(APF_DIR) -I$(SRC_DIR)

# show many warnings
CXXFLAGS += -Wall -Wextra
CXXFLAGS += -pedantic
# warnings are errors
CXXFLAGS += -pedantic-errors
CXXFLAGS += -Werror
# even more warnings:
CXXFLAGS += -Wpointer-arith
CXXFLAGS += -Wcast-align
CXXFLAGS += -Wwrite-strings
CXXFLAGS += -Wredundant-decls
#CXXFLAGS += -Wlong-long
#CXXFLAGS += -Wconversion
#CXXFLAGS += -Wsign-conversion
#CXXFLAGS += -Wshadow
#CXXFLAGS += -Wold-style-cast
#CXXFLAGS += -Winline

PKG_CONFIG ?= pkg-config
MEX_CPPFLAGS += `$(PKG_CONFIG) --cflags $(LIBRARIES)`
MEX_LDLIBS += `$(PKG_CONFIG) --libs $(LIBRARIES)`

CPPFLAGS += $(MEX_CPPFLAGS)
CFLAGS += $(MEX_CFLAGS)
CXXFLAGS += $(MEX_CXXFLAGS)
LDLIBS += $(MEX_LDLIBS)

# don't use implicit rules:
.SUFFIXES:

all: octave matlab

octave: $(OCTAVE_TARGETS)

matlab: $(MATLAB_TARGETS)

# Targets have different extension depending on the platform.
# To avoid finding out the extension, we use empty *.stamp files.

$(OCTAVE_TARGETS) $(MATLAB_TARGETS): %: .%.stamp

.%.octave.stamp: %.cpp $(SOURCES)
	CC="$(CXX)" CXX="$(CXX)" LD="$(CXX)" \
	   CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" \
	   $(OCT) $(MEX_CPPFLAGS) $(MEX_CFLAGS) $(MEX_CXXFLAGS) $(MEX_LDLIBS) $^
	@touch $@

# TODO: this works for 64bit systems, check if it also works on 32bit
.%.matlab.stamp: CXXFLAGS += -fPIC

.%.matlab.stamp: %.cpp $(SOURCES)
	$(MEX) $(MEX_CPPFLAGS) $(MEX_CFLAGS) $(MEX_CXXFLAGS) $(MEX_LDLIBS) \
		CC="$(CXX)" CXX="$(CXX)" LD="$(CXX)" \
		CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" $^
	@touch $@

# To specify MEX file name: -output bla

clean:
	$(RM) $(MEXFILES:%=%.mexa64)
	$(RM) $(MEXFILES:%=%.mexglx)
	$(RM) $(MEXFILES:%=%.mexmaci)
	$(RM) $(MEXFILES:%=%.mexmaci64)
	$(RM) $(MEXFILES:%=%.mex)
	$(RM) *.o
	$(RM) .*.stamp

.PHONY: all octave matlab clean $(OCTAVE_TARGETS) $(MATLAB_TARGETS)

.DELETE_ON_ERROR:

=== apf/examples/Makefile ===
JACK_STUFF += jack_simpleprocessor jack_dynamic_inputs jack_dynamic_outputs
JACK_STUFF += jack_minimal jack_matrix jack_query_thread
JACK_STUFF += jack_convolver
JACK_STUFF += jack_change_volume
JACK_STUFF += jack_connections

PORTAUDIO_STUFF += portaudio_simpleprocessor

SNDFILE_STUFF += audiofile_simpleprocessor
SNDFILE_STUFF += jack_convolver

FFTW_STUFF += jack_convolver

EXECUTABLES += $(SNDFILE_STUFF) $(JACK_STUFF) $(PORTAUDIO_STUFF) $(FFTW_STUFF)
EXECUTABLES += dummy_example

MEX_FILES = mex_simpleprocessor.mex

OPT ?= -O3

CXXFLAGS += $(OPT)
CXXFLAGS += -g

CXXFLAGS += -std=c++11

LDLIBS += -lpthread

# show all warnings
CXXFLAGS += -Wall -Wextra
CXXFLAGS += -pedantic
# warnings are errors
CXXFLAGS += -pedantic-errors
CXXFLAGS += -Werror
# even more warnings:
CXXFLAGS += -Wpointer-arith
CXXFLAGS += -Wcast-align
CXXFLAGS += -Wwrite-strings
CXXFLAGS += -Wredundant-decls
CXXFLAGS += -Wshadow
CXXFLAGS += -Wold-style-cast
CXXFLAGS += -Wlong-long
CXXFLAGS += -Wconversion
#CXXFLAGS += -Winline
#CXXFLAGS += -Weffc++

CPPFLAGS += -I.. -D_REENTRANT

#### no more setting below here ####

FLEXTPATH ?= /usr/local/src/flext

# without this, intermediate .o files are generated:
.SUFFIXES:
.SUFFIXES: .cpp .o

# this adds (very slow) runtime checks for many STL functions:
debug: CPPFLAGS += -D_GLIBCXX_DEBUG
debug: all

no-debug: CPPFLAGS += -DNDEBUG
no-debug: all

all: $(EXECUTABLES)

.PHONY: debug no-debug all

$(JACK_STUFF): LDLIBS += -ljack
$(JACK_STUFF): CPPFLAGS += -DAPF_JACK_POLICY_DEBUG

$(SNDFILE_STUFF): LDLIBS += -lsndfile

$(PORTAUDIO_STUFF): LDLIBS += -lportaudio

$(FFTW_STUFF): LDLIBS += -lfftw3f

# For Puredata stuff see also package.txt

pd: $(FLEXTPATH) package.txt
	$(FLEXTPATH)/build.sh pd gcc

.PHONY: pd

$(FLEXTPATH):
	@test -d $(FLEXTPATH) || \
		( echo \"$(FLEXTPATH)\" not found! Set FLEXTPATH! ; false )

mex: CPPFLAGS += -DNDEBUG
mex: $(MEX_FILES)

mex-double: CPPFLAGS += -DMEX_USE_DOUBLE
mex-double: mex

.PHONY: mex mex-double

%.mex: %.cpp
	CXXFLAGS="$(CXXFLAGS)" mkoctfile --mex $< $(CPPFLAGS)
	$(RM) $*.o

clean:
	$(RM) $(EXECUTABLES) $(OBJECTS)
	test -d $(FLEXTPATH) && $(FLEXTPATH)/build.sh pd gcc clean || true
	rmdir pd-linux || true
	$(RM) $(MEX_FILES)

.PHONY: clean

# rebuild everything when Makefile changes
$(OBJECTS) $(EXECUTABLES) $(PD_EXTERNALS) $(MEX_FILES): Makefile

DEPENDENCIES = $(EXECUTABLES) $(OBJECTS)

include ../misc/Makefile.dependencies

=== apf/unit_tests/Makefile ===
# Makefile for unit tests

TESTS += test_math
TESTS += test_stringtools
TESTS += test_trivial_iterator
TESTS += test_iterator
TESTS += test_accumulating_iterator
TESTS += test_cast_iterator
TESTS += test_circular_iterator
TESTS += test_transform_iterator
TESTS += test_index_iterator
TESTS += test_stride_iterator
TESTS += test_dual_iterator
TESTS += test_discard_iterator
TESTS += test_iterator_combinations
TESTS += test_biquad
TESTS += test_blockdelayline
TESTS += test_container
TESTS += test_mimoprocessor
TESTS += test_combine_channels
TESTS += test_misc

ifneq (,$(findstring $(MAKECMDGOALS), fftw clean))
TESTS += test_fftwtools
TESTS += test_convolver
endif

OBJECTS = $(TESTS:=.o)

CXXFLAGS += -std=c++11

CXXFLAGS += -g

# show all warnings
CXXFLAGS += -Wall -Wextra
CXXFLAGS += -pedantic
# warnings are errors
CXXFLAGS += -pedantic-errors
#CXXFLAGS += -Werror
# even more warnings:
CXXFLAGS += -Wpointer-arith
CXXFLAGS += -Wcast-align
CXXFLAGS += -Wwrite-strings
CXXFLAGS += -Wredundant-decls
CXXFLAGS += -Wconversion
CXXFLAGS += -Wshadow
CXXFLAGS += -Wold-style-cast
CXXFLAGS += -Wlong-long
CXXFLAGS += -Winline

#CXXFLAGS += -Wno-sign-conversion

CPPFLAGS += -I..

# this adds (very slow) runtime checks for many STL functions:
CPPFLAGS += -D_GLIBCXX_DEBUG

all:
	$(MAKE) fftw

run_tests: build_tests
	./main

build_tests: main

fftw: LDLIBS += -lfftw3f -lfftw3 -lfftw3l -lm
fftw: run_tests

main: $(OBJECTS)

# TODO: check why this gives false(?) positives in test_blockdelayline.h
test_blockdelayline.o: CPPFLAGS := $(filter-out -D_GLIBCXX_DEBUG,$(CPPFLAGS))

DEPENDENCIES = main $(OBJECTS)

clean:
	$(RM) $(DEPENDENCIES)

.PHONY: all build_tests run_tests clean fftw

# rebuild everything when Makefile changes
$(DEPENDENCIES): Makefile

include ../misc/Makefile.dependencies

=== debian/changelog ===
soundscaperenderer (0.4.1~dfsg-2) unstable; urgency=medium

  * export BOOST_LIB_DIR (Closes #747540, #747811)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 12 May 2014 11:49:11 +0200

soundscaperenderer (0.4.1~dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #738659)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 08 May 2014 16:58:09 +0200

=== debian/control ===
Source: soundscaperenderer
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
Build-Depends: cdbs,
 debhelper,
 dh-buildinfo,
 dh-autoreconf,
 libboost-system-dev,
 libboost-thread-dev,
 libqt4-dev,
 libqt4-opengl-dev,
 libecasoundc-dev,
 libsndfile1-dev,
 libjack-dev | libjack-jackd2-dev,
 libfftw3-dev,
 libxml2-dev,
 help2man
Build-Depends-Indep:
 latexmk,
 ghostscript,
 texlive-fonts-recommended,
 texlive-latex-extra
Standards-Version: 3.9.5
Homepage: http://spatialaudio.net/ssr/
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/soundscaperenderer
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/soundscaperenderer.git

Package: soundscaperenderer-nox
Architecture: any
Depends: soundscaperenderer-common,
 ${shlibs:Depends},
 ${misc:Depends}
Description: tool for real-time spatial audio reproduction (without X support)
 The SoundScape Renderer (SSR) is a tool for real-time spatial audio
 reproduction providing a variety of rendering algorithms, e.g. Wave Field
 Synthesis, Higher-Order Ambisonics and binaural techniques.
 .
 This package contains a version of SSR compiled without X support.

Package: soundscaperenderer
Architecture: any
Depends: soundscaperenderer-common,
 ${shlibs:Depends},
 ${misc:Depends}
Description: tool for real-time spatial audio reproduction
 The SoundScape Renderer (SSR) is a tool for real-time spatial audio
 reproduction providing a variety of rendering algorithms, e.g. Wave Field
 Synthesis, Higher-Order Ambisonics and binaural techniques.
 .
 This package contains a version of SSR compiled with graphical interface using
 Qt.

Package: soundscaperenderer-common
Architecture: all
Depends: ${shlibs:Depends},
 ${misc:Depends}
Recommends: soundscaperenderer | soundscaperenderer-nox
Description: tool for real-time spatial audio reproduction (common-files)
 The SoundScape Renderer (SSR) is a tool for real-time spatial audio
 reproduction providing a variety of rendering algorithms, e.g. Wave Field
 Synthesis, Higher-Order Ambisonics and binaural techniques.
 .
 This package contains common files for all flavours of SSR.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2014 IOhannes m zmölnig <zmoelnig@iem.at>
# Description: Main Debian packaging script for SoundScape Renderer
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# needs to be declared before including makefile.mk
DEB_MAKE_FLAVORS = qt nox
DEB_BUILDDIR = build

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/autoreconf.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_MAKE_CHECK_TARGET = check

CDBS_BUILD_DEPENDS_rules_utils_copyright-check =
CDBS_BUILD_DEPENDS_rules_utils_buildinfo =

export BOOST_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

# global configure options
## disables all optimization
## (x86_64 should be turned on automatically by the compiler)
DEB_CONFIGURE_EXTRA_FLAGS = --disable-optimization
# per flavor configure options
DEB_CONFIGURE_EXTRA_FLAGS_qt  = --enable-gui  --program-suffix=.qt
DEB_CONFIGURE_EXTRA_FLAGS_nox = --disable-gui --program-suffix=.nox
DEB_CONFIGURE_EXTRA_FLAGS += $(DEB_CONFIGURE_EXTRA_FLAGS_$(cdbs_make_curflavor))

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(doc/manual/images/.*\.(png|eps)|data/images/.*\.png|data/MacOSX/.*/.*\.(png|jpg)|data/MacOSX/(SSRIcon.icns|run-ssr.scpt)|data/impulse_responses/hrirs/hrirs_fabian\.wav|data/impulse_responses/wfs_prefilters/wfs_prefilter_[0-9]*_[0-9]*_[0-9]*\.wav|debian/(changelog|copyright(|_hints|_newhints)))$

DEB_INSTALL_MANPAGES_soundscaperenderer="--language=C"
DEB_INSTALL_MANPAGES_soundscaperenderer-nox="--language=C"


build/soundscaperenderer-common::
	cd doc/manual && (latexmk; latexmk)
cleanbuilddir/soundscaperenderer-common::
	test -e doc/manual/SoundScapeRenderer.pdf && ( cd doc/manual && latexmk -C ) || true
binary-install/soundscaperenderer-common::
	rm -rf $(CURDIR)/debian/$(cdbs_curpkg)/usr/share/ssr/images/

build/soundscaperenderer-nox::
	$(CURDIR)/debian/scripts/help2man $(CURDIR)/$(DEB_BUILDDIR)/nox/src $(CURDIR)/build/manpages .nox.1
build/soundscaperenderer::
	$(CURDIR)/debian/scripts/help2man $(CURDIR)/$(DEB_BUILDDIR)/qt/src $(CURDIR)/build/manpages .qt.1

clean::
	rm -rf $(CURDIR)/build/

## soundscaperenderer 0.4.2~dfsg

=== flext/Makefile ===
# Makefile to generate externals for Puredata

# see also package.txt

# The flext build system doesn't support compiling multiple externals at once,
# so we work around this with PD_TARGETS and specify NAME here.

EXTERNALS ?= ssr_binaural ssr_nfc_hoa ssr_aap ssr_wfs ssr_vbap

PD_TARGETS := $(EXTERNALS:%=%_pd)

FLEXTPATH ?= /usr/local/src/flext

all: pd

pd: $(PD_TARGETS)

%_pd: %.cpp check_flext_path
	NAME='$(@:%_pd=%~)' MAIN_SOURCE='$<' $(FLEXTPATH)/build.sh pd gcc

check_flext_path:
	@test -n '$(FLEXTPATH)' || ( echo \"FLEXTPATH\" is empty! ; false )
	@test -d '$(FLEXTPATH)' || \
		( echo \"$(FLEXTPATH)\" not found! Set FLEXTPATH! ; false )

clean: $(EXTERNALS:%=%_pd_clean)

%_pd_clean: check_flext_path
	NAME='$(@:%_pd_clean=%~)' $(FLEXTPATH)/build.sh pd gcc clean
	@rmdir pd-linux 2> /dev/null || true

.PHONY: all pd clean check_flext_path

# TODO: When adding $(PD_TARGETS) to .PHONY, it ceases to work ... why?

=== mex/Makefile ===
# Makefile for building MEX-files

# Makefile example:
# http://www.klab.caltech.edu/~harel/share/gbvs_scale/sift/Makefile

MEXFILES ?= ssr_nfc_hoa ssr_binaural ssr_vbap ssr_aap ssr_wfs

OBJECTS := ssr_global position orientation directionalpoint xmlparser

LIBRARIES += libxml-2.0 fftw3f sndfile

APF_DIR ?= ../apf
SRC_DIR ?= ../src
MEX ?= mex -v
OCT ?= mkoctfile --mex --verbose

CXXFLAGS += -std=c++11

# optimization:
CXXFLAGS_OPT += -O3
#CXXFLAGS_OPT += -fomit-frame-pointer -ffast-math -funroll-loops
#CXXFLAGS_OPT += -march=native
CPPFLAGS += -DNDEBUG
# TODO: check for SSE?

CXXFLAGS += -pthread

# TODO: this works for 64bit systems, check if it also works on 32bit
CXXFLAGS += -fPIC

# maybe for Mac OS X:
#CFLAGS += -fno-common -no-cpp-precomp -fexceptions

#CPPFLAGS += -DSSR_MEX_USE_DOUBLE

# show many warnings
CXXFLAGS += -Wall -Wextra
CXXFLAGS += -pedantic
# warnings are errors
CXXFLAGS += -pedantic-errors
CXXFLAGS += -Werror
# even more warnings:
CXXFLAGS += -Wpointer-arith
CXXFLAGS += -Wcast-align
CXXFLAGS += -Wwrite-strings
CXXFLAGS += -Wredundant-decls
#CXXFLAGS += -Wlong-long
#CXXFLAGS += -Wconversion
#CXXFLAGS += -Wsign-conversion
#CXXFLAGS += -Wshadow
#CXXFLAGS += -Wold-style-cast
#CXXFLAGS += -Winline

PKG_CONFIG ?= pkg-config
LDLIBS += `$(PKG_CONFIG) --libs $(LIBRARIES)`
CPPFLAGS += `$(PKG_CONFIG) --cflags $(LIBRARIES)`

CPPFLAGS += -I$(APF_DIR) -I$(SRC_DIR)

OCTAVE_TARGETS := $(MEXFILES:%=%.octave)
MATLAB_TARGETS := $(MEXFILES:%=%.matlab)

OBJECTS := $(OBJECTS:%=%.o)

CXXFLAGS += $(CXXFLAGS_OPT)

# prevent make from deleting intermediate files:
.SECONDARY:

vpath %.cpp $(SRC_DIR)

all:
	$(MAKE) octave
	$(MAKE) matlab

octave: $(OCTAVE_TARGETS)

matlab: $(MATLAB_TARGETS)

# Rebuild objects if Makefile has changed:
$(OBJECTS): Makefile

# Targets have different extension depending on the platform.
# To avoid finding out the extension, we use empty *.stamp files.

$(OCTAVE_TARGETS) $(MATLAB_TARGETS): %: %.stamp

STAMPFILES := $(OCTAVE_TARGETS:%=%.stamp) $(MATLAB_TARGETS:%=%.stamp)

%.octave.stamp: %.cpp $(OBJECTS) | Makefile
	CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)" $(OCT) $(CPPFLAGS) $(LDLIBS) $< \
	    $(filter %.o, $^)
	@touch $@

# TODO: somehow add -O3 to linking step

%.matlab.stamp: %.cpp $(OBJECTS) | Makefile
	$(MEX) $(CPPFLAGS) $(LDLIBS) CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)" \
	    CXXOPTIMFLAGS="$(CXXFLAGS_OPT)" LDOPTIMFLAGS="$(CXXFLAGS_OPT)" $< \
	    $(filter %.o, $^)
	@touch $@

# Reminder: to specify MEX file name: -output bla

clean:
	$(RM) $(MEXFILES:%=%.mexa64)
	$(RM) $(MEXFILES:%=%.mexglx)
	$(RM) $(MEXFILES:%=%.mexmaci)
	$(RM) $(MEXFILES:%=%.mexmaci64)
	$(RM) $(MEXFILES:%=%.mex)
	$(RM) $(MEXFILES:%=%.o)  # mkoctfile creates these
	$(RM) $(OBJECTS)
	$(RM) $(STAMPFILES)

.PHONY: all octave matlab clean $(OCTAVE_TARGETS) $(MATLAB_TARGETS)

.DELETE_ON_ERROR:

DEPENDENCIES := $(OBJECTS) $(STAMPFILES)
BINARY_EXTENSIONS := .o .octave.stamp .matlab.stamp
include ../apf/misc/Makefile.dependencies

=== apf/examples/Makefile ===
--- 
+++ 
@@ -75,14 +75,17 @@
 
 # For Puredata stuff see also package.txt
 
-pd: $(FLEXTPATH) package.txt
+pd: check_flext_path package.txt
 	$(FLEXTPATH)/build.sh pd gcc
 
 .PHONY: pd
 
-$(FLEXTPATH):
-	@test -d $(FLEXTPATH) || \
+check_flext_path:
+	@test -n '$(FLEXTPATH)' || ( echo \"FLEXTPATH\" is empty! ; false )
+	@test -d '$(FLEXTPATH)' || \
 		( echo \"$(FLEXTPATH)\" not found! Set FLEXTPATH! ; false )
+
+.PHONY: check_flext_path
 
 mex: CPPFLAGS += -DNDEBUG
 mex: $(MEX_FILES)
@@ -99,7 +102,7 @@
 clean:
 	$(RM) $(EXECUTABLES) $(OBJECTS)
 	test -d $(FLEXTPATH) && $(FLEXTPATH)/build.sh pd gcc clean || true
-	rmdir pd-linux || true
+	@rmdir pd-linux 2> /dev/null || true
 	$(RM) $(MEX_FILES)
 
 .PHONY: clean

=== apf/performance_tests/Makefile ===
EXECUTABLES += crossfade
EXECUTABLES += interpolation
EXECUTABLES += biquad_denormals
EXECUTABLES += biquad_count_denormals

OPT ?= -O3

# TODO: automatic tests of different combinations for biquad_denormals:
OPT += -march=native
#OPT += -mfpmath=sse
#OPT += -msse
#OPT += -msse3

CXXFLAGS += $(OPT)
CXXFLAGS += -g

CXXFLAGS += -std=c++11

LDLIBS += -lpthread

# show all warnings
CXXFLAGS += -Wall -Wextra
CXXFLAGS += -pedantic
# warnings are errors
CXXFLAGS += -pedantic-errors
CXXFLAGS += -Werror
# even more warnings:
CXXFLAGS += -Wpointer-arith
CXXFLAGS += -Wcast-align
CXXFLAGS += -Wwrite-strings
CXXFLAGS += -Wredundant-decls
CXXFLAGS += -Wconversion
CXXFLAGS += -Wshadow
CXXFLAGS += -Wold-style-cast
CXXFLAGS += -Wlong-long
CXXFLAGS += -Wconversion
#CXXFLAGS += -Winline
#CXXFLAGS += -Weffc++

CPPFLAGS += -I..
CPPFLAGS += -D_REENTRANT
CPPFLAGS += -DNDEBUG

#### no more setting below here ####

# without this, intermediate .o files are generated:
.SUFFIXES:
.SUFFIXES: .cpp .o

all: $(EXECUTABLES)

.PHONY: all

clean:
	$(RM) $(EXECUTABLES) $(OBJECTS)

.PHONY: clean

# rebuild everything when Makefile changes
$(OBJECTS) $(EXECUTABLES): Makefile

DEPENDENCIES = $(EXECUTABLES) $(OBJECTS)

include ../misc/Makefile.dependencies

=== apf/unit_tests/Makefile ===
--- 
+++ 
@@ -19,6 +19,7 @@
 TESTS += test_mimoprocessor
 TESTS += test_combine_channels
 TESTS += test_misc
+TESTS += test_parameter_map
 
 ifneq (,$(findstring $(MAKECMDGOALS), fftw clean))
 TESTS += test_fftwtools

=== debian/changelog ===
soundscaperenderer (0.4.2~dfsg-5) unstable; urgency=medium

  * Override date string in documentation to a reproducible value.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 04 Nov 2015 12:48:50 +0100

soundscaperenderer (0.4.2~dfsg-4) unstable; urgency=medium

  * Update Vcs-Browser stanza
  * Added debian/git-tuneclone.sh script
  * Regenerated debian/control
    - (LP: #1408181)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 03 Nov 2015 14:19:48 +0100

soundscaperenderer (0.4.2~dfsg-3) unstable; urgency=medium

  * Depend on "jackd" as it is required to run ssr
  * Recommend "ecasound" for file playback (LP: #1408181)
  * More descriptive error-message (Closes: #749529)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 24 Aug 2015 19:37:56 +0200

soundscaperenderer (0.4.2~dfsg-2) unstable; urgency=medium

  * Worked around template-bug in g++ (Closes: #761529)
  * Ignore newly introduced wav-files
  * Exclude upstreams .gitignore
  * Updated debian/copyright
  * Regenerated debian/(copyright_hints|control)
  * Fixed 'Closes:' stanza in changelog-entry for 0.4.1~dfsg-2
  * Bumped standards to 3.9.6

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 18 Sep 2014 17:18:42 +0200

soundscaperenderer (0.4.2~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 0.4.2~dfsg

  * Refreshed patches.
  * Removed patches applied upstream.
  * Install upstream's NEWS as changelog.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 01 Sep 2014 11:35:32 +0200

=== debian/control ===
--- 
+++ 
@@ -22,16 +22,18 @@
  ghostscript,
  texlive-fonts-recommended,
  texlive-latex-extra
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://spatialaudio.net/ssr/
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/soundscaperenderer
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/soundscaperenderer.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/soundscaperenderer.git
 
 Package: soundscaperenderer-nox
 Architecture: any
 Depends: soundscaperenderer-common,
+ jackd,
  ${shlibs:Depends},
  ${misc:Depends}
+Recommends: ecasound
 Description: tool for real-time spatial audio reproduction (without X support)
  The SoundScape Renderer (SSR) is a tool for real-time spatial audio
  reproduction providing a variety of rendering algorithms, e.g. Wave Field
@@ -42,8 +44,10 @@
 Package: soundscaperenderer
 Architecture: any
 Depends: soundscaperenderer-common,
+ jackd,
  ${shlibs:Depends},
  ${misc:Depends}
+Recommends: ecasound
 Description: tool for real-time spatial audio reproduction
  The SoundScape Renderer (SSR) is a tool for real-time spatial audio
  reproduction providing a variety of rendering algorithms, e.g. Wave Field

=== debian/rules ===
--- 
+++ 
@@ -41,15 +41,19 @@
 DEB_CONFIGURE_EXTRA_FLAGS_nox = --disable-gui --program-suffix=.nox
 DEB_CONFIGURE_EXTRA_FLAGS += $(DEB_CONFIGURE_EXTRA_FLAGS_$(cdbs_make_curflavor))
 
-DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(doc/manual/images/.*\.(png|eps)|data/images/.*\.png|data/MacOSX/.*/.*\.(png|jpg)|data/MacOSX/(SSRIcon.icns|run-ssr.scpt)|data/impulse_responses/hrirs/hrirs_fabian\.wav|data/impulse_responses/wfs_prefilters/wfs_prefilter_[0-9]*_[0-9]*_[0-9]*\.wav|debian/(changelog|copyright(|_hints|_newhints)))$
+DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(doc/manual/images/.*\.(png|eps)|data/images/.*\.png|data/MacOSX/.*/.*\.(png|jpg)|data/MacOSX/(SSRIcon.icns|run-ssr.scpt)|data/impulse_responses/hrirs/hrirs_fabian\.wav|data/impulse_responses/wfs_prefilters/wfs_prefilter_[0-9]*_[0-9]*_[0-9]*\.wav|flext/(hrirs_fabian|wfs_prefilter_120_1500_44100)\.wav|debian/(changelog|copyright(|_hints|_newhints)))$
 
 DEB_INSTALL_MANPAGES_soundscaperenderer="--language=C"
 DEB_INSTALL_MANPAGES_soundscaperenderer-nox="--language=C"
 
+DEB_INSTALL_CHANGELOGS_soundscaperenderer-common=NEWS
+
 
 build/soundscaperenderer-common::
+	debian/scripts/version-tex.sh $(DEB_VERSION) > doc/manual/overrides.tex
 	cd doc/manual && (latexmk; latexmk)
 cleanbuilddir/soundscaperenderer-common::
+	rm -f doc/manual/overrides.tex
 	test -e doc/manual/SoundScapeRenderer.pdf && ( cd doc/manual && latexmk -C ) || true
 binary-install/soundscaperenderer-common::
 	rm -rf $(CURDIR)/debian/$(cdbs_curpkg)/usr/share/ssr/images/

## soundscaperenderer 0.5.0~dfsg

=== flext/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # The flext build system doesn't support compiling multiple externals at once,
 # so we work around this with PD_TARGETS and specify NAME here.
 
-EXTERNALS ?= ssr_binaural ssr_nfc_hoa ssr_aap ssr_wfs ssr_vbap
+EXTERNALS ?= ssr_binaural ssr_dca ssr_aap ssr_wfs ssr_vbap
 
 PD_TARGETS := $(EXTERNALS:%=%_pd)

=== mex/Makefile ===
--- 
+++ 
@@ -3,7 +3,8 @@
 # Makefile example:
 # http://www.klab.caltech.edu/~harel/share/gbvs_scale/sift/Makefile
 
-MEXFILES ?= ssr_nfc_hoa ssr_binaural ssr_vbap ssr_aap ssr_wfs
+MEXFILES ?= ssr_dca ssr_binaural ssr_vbap ssr_aap ssr_wfs ssr_generic \
+  ssr_brs
 
 OBJECTS := ssr_global position orientation directionalpoint xmlparser
 
@@ -38,7 +39,8 @@
 CXXFLAGS += -pedantic
 # warnings are errors
 CXXFLAGS += -pedantic-errors
-CXXFLAGS += -Werror
+# TODO: re-enable when deprecated dynamic exception specifications are removed:
+#CXXFLAGS += -Werror
 # even more warnings:
 CXXFLAGS += -Wpointer-arith
 CXXFLAGS += -Wcast-align

=== apf/examples/Makefile ===
--- 
+++ 
@@ -21,9 +21,7 @@
 CXXFLAGS += $(OPT)
 CXXFLAGS += -g
 
-CXXFLAGS += -std=c++11
-
-LDLIBS += -lpthread
+CXXFLAGS += -std=c++11 -pthread
 
 # show all warnings
 CXXFLAGS += -Wall -Wextra
@@ -43,7 +41,7 @@
 #CXXFLAGS += -Winline
 #CXXFLAGS += -Weffc++
 
-CPPFLAGS += -I.. -D_REENTRANT
+CPPFLAGS += -I..
 
 #### no more setting below here ####
 
@@ -88,6 +86,8 @@
 .PHONY: check_flext_path
 
 mex: CPPFLAGS += -DNDEBUG
+# Compile unconditionally to allow switching between float and double:
+mex: clean-mex
 mex: $(MEX_FILES)
 
 mex-double: CPPFLAGS += -DMEX_USE_DOUBLE
@@ -99,13 +99,15 @@
 	CXXFLAGS="$(CXXFLAGS)" mkoctfile --mex $< $(CPPFLAGS)
 	$(RM) $*.o
 
-clean:
+clean: clean-mex
 	$(RM) $(EXECUTABLES) $(OBJECTS)
 	test -d $(FLEXTPATH) && $(FLEXTPATH)/build.sh pd gcc clean || true
 	@rmdir pd-linux 2> /dev/null || true
+
+clean-mex:
 	$(RM) $(MEX_FILES)
 
-.PHONY: clean
+.PHONY: clean clean-mex
 
 # rebuild everything when Makefile changes
 $(OBJECTS) $(EXECUTABLES) $(PD_EXTERNALS) $(MEX_FILES): Makefile

=== apf/performance_tests/Makefile ===
--- 
+++ 
@@ -14,9 +14,7 @@
 CXXFLAGS += $(OPT)
 CXXFLAGS += -g
 
-CXXFLAGS += -std=c++11
-
-LDLIBS += -lpthread
+CXXFLAGS += -std=c++11 -pthread
 
 # show all warnings
 CXXFLAGS += -Wall -Wextra
@@ -38,7 +36,6 @@
 #CXXFLAGS += -Weffc++
 
 CPPFLAGS += -I..
-CPPFLAGS += -D_REENTRANT
 CPPFLAGS += -DNDEBUG
 
 #### no more setting below here ####

=== apf/unit_tests/Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 CXXFLAGS += -pedantic
 # warnings are errors
 CXXFLAGS += -pedantic-errors
-#CXXFLAGS += -Werror
+CXXFLAGS += -Werror
 # even more warnings:
 CXXFLAGS += -Wpointer-arith
 CXXFLAGS += -Wcast-align

=== doc/manual/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Homepage.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Homepage.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Homepage"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Homepage"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
soundscaperenderer (0.5.0~dfsg-7) unstable; urgency=medium

  * Show error messages instead of exception backtraces (Closes: #1029102)
  * Print used renderer when starting the generic 'ssr' wrapper
  * Ensure that 'licensecheck' is run with the C.UTF-8 locale
  * Bump standards version to 4.6.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 18 Jan 2023 09:23:44 +0100

soundscaperenderer (0.5.0~dfsg-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Modernize 'licensecheck' target
    + Re-generate d/copyright
  * shell fixes for common ssr-maintainerscript snippet

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 05 Dec 2022 12:49:46 +0100

soundscaperenderer (0.5.0~dfsg-5) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ IOhannes m zmölnig ]
  * Switch from cdbs to dh
  * Split B-Ds into Arch & Indep
  * Add patch for flavored 'ssr' wrapper
  * soundscaperenderer-common
    * Move runtime icons to soundscaperenderer-common
    * Build HTML-documentation rather than PDF
  * Use pre-generated manpages
    * Fix UTF-8 characters in manpages
    * Specify manpage language as C
  * d/scripts/alternatives
    + Don't fail if there are no alternatives
    + Fix typo in helper-script
  * Have "soundscaperenderer" not depend on itself
  * Bump copyright dates
  * Apply 'wrap-and-sort -ast'
  * Add salsa-ci configuration
  * Remove obsolete file d/source/local-options
  * Bump dh-compat to 13
  * Bump standards version to 4.6.0


 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 24 Nov 2021 16:57:50 +0100

soundscaperenderer (0.5.0~dfsg-4) unstable; urgency=medium

  * Fix typo in ssr-nox install paths (Closes: #926311)
  * Bump standards version to 4.3.0
    - no changes required

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 13 Apr 2019 20:06:32 +0200

soundscaperenderer (0.5.0~dfsg-3) unstable; urgency=medium

  * Don't build Qt-packages on armel/armhf (Closes: #914143)
  * B-D on non-virtual libqt5opengl5-dev package

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 20 Nov 2018 11:07:41 +0100

soundscaperenderer (0.5.0~dfsg-2) unstable; urgency=medium

  * Centralize the update-alternative handling (Closes: #914085)
  * B-D on libqt5opengl5-desktop-dev
  * Build and install documentation
  * Added description to ssr-dca manpage
  * Updated d/copyright
    * Refreshed d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 19 Nov 2018 21:08:02 +0100

soundscaperenderer (0.5.0~dfsg-1) unstable; urgency=medium

  * New upstream version 0.5.0~dfsg
    * Refreshed patches and removed those applied upstream

  * Switched to Qt5 (Closes: #875188)
  * Switched to libasio for networking
  * Use sphinx for building documentation
  * Use wildcards for installing manpages
  * Dropped B-D on dh-autoreconc
  * Dropped B-D-Indep
  * Versioned depends on -common package

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 17 Nov 2018 22:44:08 +0100

soundscaperenderer (0.4.2~dfsg-7) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ IOhannes m zmölnig ]
  * Added patch to allow compilation with recent boost
  * Declare that "root" is not required for building the package
  * Mark soundscaperenderer-common as "Multi-Arch: foreign"
  * Refresh d/copyright_hints
  * Drop d/control.in
  * Bump dh-compat to 10
  * Bump standards-version to 4.2.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 16 Nov 2018 23:11:22 +0100

soundscaperenderer (0.4.2~dfsg-6) unstable; urgency=medium

  * Added tex-override to resurrect missing '\bf' (Closes: #827630)
  * Document git-tuneclone.sh in debian/README.source
  * Removed duplicate shebang
  * Refreshed d/copyright(_hints)
  * Switched Vcs-Git stanza to https://
  * Bumped standards to 3.9.8

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 01 Jul 2016 16:13:19 +0200

=== debian/control ===
Source: soundscaperenderer
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-buildinfo,
 libfftw3-dev,
 libjack-dev | libjack-jackd2-dev,
 libsndfile1-dev,
 libxml2-dev,
 pkg-config,
Build-Depends-Arch:
 libasio-dev,
 libecasoundc-dev,
 libqt5opengl5-dev [!armel !armhf],
Build-Depends-Indep:
 python3-sphinx,
 python3-sphinx-rtd-theme,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://spatialaudio.net/ssr/
Vcs-Git: https://salsa.debian.org/multimedia-team/soundscaperenderer.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/soundscaperenderer

Package: soundscaperenderer-nox
Architecture: any
Depends:
 jackd,
 soundscaperenderer-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ecasound,
Description: tool for real-time spatial audio reproduction (without X support)
 The SoundScape Renderer (SSR) is a tool for real-time spatial audio
 reproduction providing a variety of rendering algorithms, e.g. Wave Field
 Synthesis, Higher-Order Ambisonics and binaural techniques.
 .
 This package contains a version of SSR compiled without X support.

Package: soundscaperenderer
Architecture: any
Depends:
 jackd,
 soundscaperenderer-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ecasound,
Description: tool for real-time spatial audio reproduction
 The SoundScape Renderer (SSR) is a tool for real-time spatial audio
 reproduction providing a variety of rendering algorithms, e.g. Wave Field
 Synthesis, Higher-Order Ambisonics and binaural techniques.
 .
 This package contains a version of SSR compiled with graphical interface using
 Qt.

Package: soundscaperenderer-common
Architecture: all
Multi-Arch: foreign
Breaks:
 soundscaperenderer (<< 0.5.0~dfsg-5~),
Replaces:
 soundscaperenderer (<< 0.5.0~dfsg-5~),
Depends:
 ${misc:Depends},
Recommends:
 soundscaperenderer | soundscaperenderer-nox,
Description: tool for real-time spatial audio reproduction (common-files)
 The SoundScape Renderer (SSR) is a tool for real-time spatial audio
 reproduction providing a variety of rendering algorithms, e.g. Wave Field
 Synthesis, Higher-Order Ambisonics and binaural techniques.
 .
 This package contains common files for all flavours of SSR.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2014-2022 IOhannes m zmölnig <zmoelnig@iem.at>
# Description: Main Debian packaging script for SoundScape Renderer
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

## some archs only have OpenGL-ES (at least with Qt):
OPENGL_ES_ARCHS := armhf armel

# needs to be declared before including makefile.mk
FLAVORS = nox
ifneq (,$(findstring $(DEB_HOST_ARCH), $(OPENGL_ES_ARCHS)))
export DH_OPTIONS=-Nsoundscaperenderer
else
FLAVORS += qt
endif
builddir=debian/build/flavor-

DEB_BUILDDIR = build

export QT_SELECT=qt5

# global configure options
## disables all optimization
## (x86_64 should be turned on automatically by the compiler)
CONFIG = --disable-optimization
# per flavor configure options
CONFIG_qt  = --enable-gui  --program-suffix=.qt
CONFIG_nox = --disable-gui --program-suffix=.nox
CONFIG_indep = --program-suffix=.indep --disable-all --disable-gui --disable-ip-interface --disable-ecasound --disable-polhemus --disable-razor --disable-vrpn --disable-intersense --disable-isatty


# Use the default debhelper scripts, where possible.
%:
	dh $@

execute_before_dh_autoreconf:
	mkdir -p autotools/config autotools/m4

# Add configuration options:
override_dh_auto_configure-indep: configure_indep
override_dh_auto_configure-arch: $(patsubst %,configure_%,$(FLAVORS))
configure_%:
	dh_auto_configure -B $(builddir)$* -- $(strip $(CONFIG) $(CONFIG_$*))

# Remove the subdirectories generated for the flavors.
override_dh_auto_clean:
	rm -rf $(patsubst %,$(builddir)%,$(FLAVORS) indep)
	rmdir -p $(dir $(builddir)) || echo "couldn't cleanup build-dirs...ignoring"
	rm -rf doc/manual/_build/

override_dh_auto_build-indep:
	dh_auto_build -i --sourcedirectory=$(builddir)indep || (cat $(builddir)indep/config.log && exit 1)
	$(CURDIR)/debian/scripts/alternatives $(CURDIR)/$(builddir)indep/src $(CURDIR)/$(builddir)indep/alternatives
# Create sphinx documentation:
	make -C $(CURDIR)/doc/manual html
override_dh_auto_build-arch: $(patsubst %,build_%,$(FLAVORS))
build_%:
	dh_auto_build -a --sourcedirectory=$(builddir)$* || (cat $(builddir)$*/config.log && exit 1)
	$(CURDIR)/debian/scripts/alternatives $(CURDIR)/$(builddir)$*/src $(CURDIR)/$(builddir)$*/alternatives

override_dh_auto_install-indep:
	dh_auto_install -i --sourcedirectory=$(builddir)indep
override_dh_auto_install-arch: $(patsubst %,install_%,$(FLAVORS))
install_%:
	dh_auto_install -a --sourcedirectory=$(builddir)$*

override_dh_installman:
	dh_installman --language=C

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|data/impulse_responses/hrirs/.*\.wav|doc/manual/images/screenshot.*\.png|data/MacOSX/SSRIcon\.icns|data/MacOSX/\.background/background\.png|data/MacOSX/dylibbundler/dylibbundler\.png
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

## soundscaperenderer 0.6.0+dfsg2

=== flext/Makefile ===
# Makefile to generate externals for Puredata

PKG_CONFIG ?= pkg-config

cflags += \
       -DFLEXT_INLINE \
       -Iflext/source \
       -I../apf \
       -I../src \
       -I../gml/include \
       `$(PKG_CONFIG) --cflags libxml-2.0` \
       -std=c++17 \
       -DENABLE_SOFA \

define forDarwin
  cflags += -mmacosx-version-min=10.15
endef

ldlibs = -lfftw3f -lsndfile -lmysofa `$(PKG_CONFIG) --libs libxml-2.0`

class.sources = \
	ssr_aap~.cpp \
	ssr_binaural~.cpp \
	ssr_brs~.cpp \
	ssr_dca~.cpp \
	ssr_wfs~.cpp \
	ssr_vbap~.cpp \

common.sources = \
	legacy_position.cpp \
	legacy_orientation.cpp \
	legacy_directionalpoint.cpp \
	ssr_global.cpp \
	xmlparser.cpp \

datafiles = \
	$(wildcard *-help.pd) \
	ssr_messages.pd \
	8channels.asd \
	circle.asd \
	hrirs_fabian_min_phase_eq.wav \
	wfs_prefilter_120_1500_44100.wav \
	brirs_1.wav \
	brirs_2.wav \

include pd-lib-builder/Makefile.pdlibbuilder

=== debian/changelog ===
soundscaperenderer (0.6.0+dfsg2-1) unstable; urgency=medium

  * New upstream version 0.6.0+dfsg2
    + Drop patches applied/obsoleted upstream
  * Remove flavored 'ssr' wrapper (the wrapper is deprecated upstream)
    + Update 'ssr' manpage
  * Disable unused websocket-interface for arch-indep build
  * Exclude more stripped files from building
  * HTML documentation
    + Don't use unpackaged sphinx extensions/themes
    + Use 'sphinx_rtd_theme'
    + Add patch to exclude 'insipid'-specific navigation hints
  * Add more Build-Dependencies
  * Mark patches as (not) forwarded
  * Exclude more files from import
    (This explains why the Debian version number says dfsg2,
    even though there was no other upload...)
  * Update d/copyright
    + Update copyright and date stanzas
    + Drop unused license from d/copyright
    + Update 'licensecheck' target
    + Re-generate d/copyright_hints
  * Update d/watch
    + Bump version to 4
    + Use release-tarball
    + Automatically add repacksuffix

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 06 Feb 2023 12:48:14 +0100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,8 @@
  libasio-dev,
  libecasoundc-dev,
  libqt5opengl5-dev [!armel !armhf],
+ libwebsocketpp-dev,
+ rapidjson-dev,
 Build-Depends-Indep:
  python3-sphinx,
  python3-sphinx-rtd-theme,

=== debian/rules ===
--- 
+++ 
@@ -39,7 +39,17 @@
 # per flavor configure options
 CONFIG_qt  = --enable-gui  --program-suffix=.qt
 CONFIG_nox = --disable-gui --program-suffix=.nox
-CONFIG_indep = --program-suffix=.indep --disable-all --disable-gui --disable-ip-interface --disable-ecasound --disable-polhemus --disable-razor --disable-vrpn --disable-intersense --disable-isatty
+CONFIG_indep = --program-suffix=.indep --disable-all \
+	--disable-gui \
+	--disable-ip-interface \
+	--disable-websocket-interface \
+	--disable-ecasound \
+	--disable-polhemus \
+	--disable-razor \
+	--disable-vrpn \
+	--disable-intersense \
+	--disable-isatty \
+	$(empty)
 
 
 # Use the default debhelper scripts, where possible.
@@ -81,7 +91,7 @@
 	dh_installman --language=C
 
 DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
-        debian/.*|data/impulse_responses/hrirs/.*\.wav|doc/manual/images/screenshot.*\.png|data/MacOSX/SSRIcon\.icns|data/MacOSX/\.background/background\.png|data/MacOSX/dylibbundler/dylibbundler\.png
+        debian/.*|flext/.*\.wav|data/impulse_responses/hrirs/.*\.wav|doc/manual/images/screenshot.*\.png|data/MacOSX/SSRIcon\.icns|data/MacOSX/\.background/background\.png|data/MacOSX/dylibbundler/dylibbundler\.png
 # licensecheck v1
 .PHONY: licensecheck
 licensecheck:

## soundscaperenderer 0.6.1%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -11,17 +11,19 @@
  libjack-dev | libjack-jackd2-dev,
  libsndfile1-dev,
  libxml2-dev,
- pkg-config,
+ pkgconf | pkg-config,
 Build-Depends-Arch:
  libasio-dev,
  libecasoundc-dev,
+ libfmt-dev,
+ libmysofa-dev,
  libqt5opengl5-dev [!armel !armhf],
  libwebsocketpp-dev,
  rapidjson-dev,
 Build-Depends-Indep:
  python3-sphinx,
  python3-sphinx-rtd-theme,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: http://spatialaudio.net/ssr/
 Vcs-Git: https://salsa.debian.org/multimedia-team/soundscaperenderer.git
